<template>
  <v-card elevation="4" class="my-5 py-2" max-width="650">
    <extra-info-specialista
      v-model="dialogExtraInfo"
      :profile-image-url="imageSpecialist"
      :specialist-uuid="idSpecialist"
      :mother-lastname="motherSpecialist"
      :father-lastname="fatherSpecialist"
      :name="nameSpecialist"
      :key="dialogKeyExtraInfo"
    />
    <v-col>
      <div class="d-flex align-center mb-2">
        <ImagePhoto :photo="imageSpecialist"/>
        <div class="ml-2 ml-md-4">
          <h2>Esp. {{ fullname }}</h2>
          <a @click="goToInfoExtra" class="body-2 esp-about"
            >SOBRE EL ESPECIALISTA</a
          >
        </div>
      </div>
      <v-list-item-subtitle class="ml-3">
        ELIGE UN HORARIO:
      </v-list-item-subtitle>
      <v-row no-gutters>
        <v-col cols="12" md="9">
          <v-container>
            <v-row no-gutters style="margin: 0 -5px">
              <v-col
                v-for="(item, index) in availabilitySpecialist"
                :key="index"
                cols="auto"
              >
                <v-btn
                  class="ma-1"
                  :value="item.startTime"
                  :color="idAvailability === item.id ? 'secondary' : 'primary'"
                  @click="getHour(index)"
                  depressed
                >
                  <span class="font-weight-light">{{
                    formatAvailable(item)
                  }}</span>
                </v-btn>
              </v-col>
            </v-row>
          </v-container>
        </v-col>
        <v-col cols="12" md="3">
          <v-container>
            <v-btn
              v-if="indexAvailavility !== -1 && indexSelected === index"
              color="primary"
              rounded
              @click="$emit('continue')"
            >
              Continuar
            </v-btn>
          </v-container>
        </v-col>
      </v-row>
    </v-col>
  </v-card>
</template>

<script>
import ExtraInfoSpecialist from "~/components/Cards/ExtraInfoSpecialist";
import ImagePhoto from '~/components/appointment/ImagePhoto';
import { formatAMPM } from "~/helpers/time";

export default {
  name: "AvailabilitySpecialistCard",
  components: {
    "extra-info-specialista": ExtraInfoSpecialist,
    ImagePhoto,
  },
  props: {
    imageSpecialist: String,
    nameSpecialist: String,
    fatherSpecialist: String,
    motherSpecialist: String,
    availabilitySpecialist: Array,
    idSpecialist: String,
    posSpecialist: Number,
    indexAvailavility: Number,
    selected: Object,
    idAvailability: Number,
    indexSelected: Number,
    index: Number,
  },
  data: () => ({
    idSchedule: [],
    dialogExtraInfo: false,
    dialogKeyExtraInfo: 1,
  }),
  mounted() {
    console.log("Disponibilidad del especialista", this.availabilitySpecialist);
  },
  computed: {
    fullname() {
      let str = `${this.nameSpecialist} ${this.fatherSpecialist} ${this.motherSpecialist}`;
      let downstr = str.toLowerCase();
      let str2 = downstr.replace(/\w\S*/g, (w) =>
        w.replace(/^\w/, (c) => c.toUpperCase())
      );
      return str2;
    },
  },
  methods: {
    formatAvailable(date) {
      const newdate = new Date(date.startTime);
      return formatAMPM(newdate);
    },
    goToInfoExtra() {
      this.dialogExtraInfo = true;
      this.forceRender();
    },
    getHour(index) {
      this.$emit("getIdAvailability", this.availabilitySpecialist[index].id);
      this.$emit("getIndexAvailability", index);
      this.$emit("getUuidSpecialist", this.idSpecialist);
      this.$emit("getIndexSpecialist", this.posSpecialist, index);
    },
    forceRender() {
      this.dialogKeyExtraInfo += 1;
    },
  },
};
</script>
<style scoped lang="scss">
.v-container-name {
  align-items: center;
}
.esp-about {
  color: #00b57c;
  text-transform: uppercase;
  font-weight: 300;
  margin-top: 10px;
}
@media only screen and (max-width: 600px) {
  h2 {
    font-size: 20px;
    line-height: 1.2;
  }
}
</style>
